<?php

/**
* $Id: items_menu.php,v 1.1.2.2 2005/08/16 16:27:59 fx2024 Exp $
* Module: SmartSection
* Author: The SmartFactory <www.smartfactory.ca>
* Licence: GNU
*/
if (!defined("XOOPS_ROOT_PATH")) { 
 	die("XOOPS root path not defined");
}

function b_items_menu_show($options)
{	
	include_once(XOOPS_ROOT_PATH."/modules/smartsection/include/common.php");	
	
	$block = array();
	If ($options[0] == 0) {
		$categoryid = -1;
	} else {
		$categoryid = $options[0];
	}
	
	$sort = $options[1];
	$order = smartsection_getOrderBy($sort);				
	$limit = $options[2];
	
	$smartsection_item_handler =& ss_gethandler('item');
	$smartsection_category_handler =& ss_gethandler('category');
	
	// Getting all top cats
	$categoriesObj = $smartsection_category_handler->getCategories();
	$array_categoryids = array_keys($categoriesObj);
	$categoryids = implode(', ', $array_categoryids);
	
	// Are we in a category and if yes, in which one ?
	$categoryid = isset($_GET['categoryid']) ? $_GET['categoryid'] : -1;
	
	// Builting the $topcategory_criteria
	$topcategory_criteria = new Criteria('categoryid', "($categoryids)", 'IN');
		
	// creating the ITEM objects that belong to the selected category
	$itemsObj = $smartsection_item_handler->getItems($limit, 0, array(_SS_STATUS_PUBLISHED), $categoryid, 'datesub', 'DESC', '', true, $topcategory_criteria, 'categoryid');
	$subCatsObj = $smartsection_category_handler->getCategories(0,0,$categoryid);
	foreach ($itemsObj as $categoryid => $itemsObj) {
		$block['categories'][$categoryid]['categoryLink'] = $categoriesObj[$categoryid]->getCategoryLink('menuMain');
		foreach ($itemsObj as $itemid=>$itemObj) {
			$block['categories'][$categoryid]['items'][$itemid]['titleLink'] = $itemObj->getItemLink('menuSub');
		}
	}
	
	$subCatsObj = $smartsection_category_handler->getCategories(0,0,$categoryid);
	
	
	return $block;	
} 

function b_items_menu_edit($options)
{
    global $xoopsDB, $xoopsModule, $xoopsUser;
	include_once(XOOPS_ROOT_PATH."/modules/smartsection/include/functions.php");
	
	$form = ss_createCategorySelect($options[0]);
	
    $form .= "&nbsp;<br>" . _MB_SS_ORDER . "&nbsp;<select name='options[]'>";

    $form .= "<option value='datesub'";
    if ($options[1] == "datesub") {
        $form .= " selected='selected'";
    } 
    $form .= ">" . _MB_SS_DATE . "</option>\n";

    $form .= "<option value='counter'";
    if ($options[1] == "counter") {
        $form .= " selected='selected'";
    } 
    $form .= ">" . _MB_SS_HITS . "</option>\n";

    $form .= "<option value='weight'";
    if ($options[1] == "weight") {
        $form .= " selected='selected'";
    } 
    $form .= ">" . _MB_SS_WEIGHT . "</option>\n";

    $form .= "</select>\n";

    $form .= "&nbsp;" . _MB_SS_DISP . "&nbsp;<input type='text' name='options[]' value='" . $options[2] . "' />&nbsp;" . _MB_SS_ITEMS . "";

    return $form;
} 

?>